///G. Hagopian - Minesweeper
#include<iostream>
#include<cstdlib>
#include<ctime>
#include<iomanip>

class Cell {
    /// private data elements here
protected:

public:
    int N; ///number of neighbors with bombs
    virtual void setN(int) = 0;
    virtual void show() = 0;
    Cell() {};
    //bool getR() { return R; }
};

class MSCell : public Cell {
    bool R; ///
public:
    MSCell() {};
    MSCell(bool r, bool f, bool b)
        : R(r), F(f), B(b) {}
    void setN(int n) { N = n; }
    bool F; ///flagged?
    bool B; ///bomb?
    void show() {
        std::cout << N;
    }
};

class MSBoard {
    int height;
    int width;
    MSCell **board;
public:
    MSBoard(int h, int w) : height(h), width(w) {
        board = new MSCell*[height]; /// dynamic array (size height) of pointers to MSCell
        for (int i = 0; i < height; ++i) {
            board[i] = new MSCell[width];
        /// each i-th pointer is now pointing to dynamic array (size wedith) of actual MSCell values
        }
        for (int i = 0; i < height; ++i) {   /// for each row
            for (int j = 0; j < width; ++j) { /// for each column
                MSCell m(false, false, rand()%2); ///construct a random cell
                board[i][j] = m;
            }
        }
        /// build neighbors
        ///treat corners:
        ///upper left
        board[0][0].N = board[0][1].B+
                        board[1][1].B+
                        board[1][0].B;
        ///upper right
        board[0][width-1].N =
                        board[1][width-1].B+
                        board[0][width-2].B+
                        board[1][width-2].B;
        ///lower right
        board[height-1][width-1].N =
                        board[height-2][width-1].B+
                        board[height-2][width-2].B+
                        board[height-1][width-2].B;
        ///lower left
        board[height-1][0].N =
                        board[height-2][0].B+
                        board[height-2][1].B+
                        board[height-1][1].B;
        ///upper row interior
        for(int i = 1; i < width-1; ++i) {
            board[0][i].N=board[0][i-1].B+
                        board[0][i+1].B+
                        board[1][i-1].B+
                        board[1][i].B+
                        board[1][i+1].B;
        }
        ///lower row interior
        for(int i = 1; i < width-1; ++i) {
            board[width-1][i].N=
                        board[height-1][i-1].B+
                        board[height-1][i+1].B+
                        board[height-2][i-1].B+
                        board[height-2][i].B+
                        board[height-2][i+1].B;
        }
        ///left column interior
        for(int i = 1; i < height-1; ++i) {
            board[i][0].N=board[i-1][0].B+
                        board[i+1][0].B+
                        board[i-1][1].B+
                        board[i][1].B+
                        board[i+1][1].B;
        }
        ///right column interior
        for(int i = 1; i < height-1; ++i) {
            board[i][width-1].N=board[i-1][width-1].B+
                        board[i+1][width-1].B+
                        board[i-1][width-2].B+
                        board[i][width-2].B+
                        board[i+1][width].B;
        }
        std::cout<< "Hi, Mom!";
        ///interior
        int n = 0;
        for(int i=1; i < height-1;++i) {
            for(int j=1; j< width-1;++j) {
                n = 0;
                for(int k = i-1;k<=i+1;++k)
                    for(int l = j-1;l<=j+1;++l) {
                        n+=board[k][l].B;
                    }
                board[i][j].N=n-board[i][j].B;
                std::cout<<"\nboard["<<i<<"]["<<j<<"].B="<<board[i][j].N;
                std::cin.get();
            }
        }
    }
    void showBoard() {
        /// print column headers:
        std::cout << "  ";
        for(char c = 'a'; c<'a'+width; ++c)
            std::cout << std::setw(3) << c;
        for (int i = 0; i < height; ++i) {   // for each row
            for (int j = 0; j < width; ++j) {
                std::cout << ' ';
                this->board[i][j].show();
                std::cout << ' ';
            }
        }
    }

};
